// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from urinterfaces:msg/ActiveTCP.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__MSG__DETAIL__ACTIVE_TCP__FUNCTIONS_H_
#define URINTERFACES__MSG__DETAIL__ACTIVE_TCP__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "urinterfaces/msg/rosidl_generator_c__visibility_control.h"

#include "urinterfaces/msg/detail/active_tcp__struct.h"

/// Initialize msg/ActiveTCP message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * urinterfaces__msg__ActiveTCP
 * )) before or use
 * urinterfaces__msg__ActiveTCP__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__msg__ActiveTCP__init(urinterfaces__msg__ActiveTCP * msg);

/// Finalize msg/ActiveTCP message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__msg__ActiveTCP__fini(urinterfaces__msg__ActiveTCP * msg);

/// Create msg/ActiveTCP message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * urinterfaces__msg__ActiveTCP__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__msg__ActiveTCP *
urinterfaces__msg__ActiveTCP__create();

/// Destroy msg/ActiveTCP message.
/**
 * It calls
 * urinterfaces__msg__ActiveTCP__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__msg__ActiveTCP__destroy(urinterfaces__msg__ActiveTCP * msg);

/// Check for msg/ActiveTCP message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__msg__ActiveTCP__are_equal(const urinterfaces__msg__ActiveTCP * lhs, const urinterfaces__msg__ActiveTCP * rhs);

/// Copy a msg/ActiveTCP message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__msg__ActiveTCP__copy(
  const urinterfaces__msg__ActiveTCP * input,
  urinterfaces__msg__ActiveTCP * output);

/// Initialize array of msg/ActiveTCP messages.
/**
 * It allocates the memory for the number of elements and calls
 * urinterfaces__msg__ActiveTCP__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__msg__ActiveTCP__Sequence__init(urinterfaces__msg__ActiveTCP__Sequence * array, size_t size);

/// Finalize array of msg/ActiveTCP messages.
/**
 * It calls
 * urinterfaces__msg__ActiveTCP__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__msg__ActiveTCP__Sequence__fini(urinterfaces__msg__ActiveTCP__Sequence * array);

/// Create array of msg/ActiveTCP messages.
/**
 * It allocates the memory for the array and calls
 * urinterfaces__msg__ActiveTCP__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__msg__ActiveTCP__Sequence *
urinterfaces__msg__ActiveTCP__Sequence__create(size_t size);

/// Destroy array of msg/ActiveTCP messages.
/**
 * It calls
 * urinterfaces__msg__ActiveTCP__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__msg__ActiveTCP__Sequence__destroy(urinterfaces__msg__ActiveTCP__Sequence * array);

/// Check for msg/ActiveTCP message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__msg__ActiveTCP__Sequence__are_equal(const urinterfaces__msg__ActiveTCP__Sequence * lhs, const urinterfaces__msg__ActiveTCP__Sequence * rhs);

/// Copy an array of msg/ActiveTCP messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__msg__ActiveTCP__Sequence__copy(
  const urinterfaces__msg__ActiveTCP__Sequence * input,
  urinterfaces__msg__ActiveTCP__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // URINTERFACES__MSG__DETAIL__ACTIVE_TCP__FUNCTIONS_H_
