// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from urinterfaces:msg/AnalogIO.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__MSG__DETAIL__ANALOG_IO__TRAITS_HPP_
#define URINTERFACES__MSG__DETAIL__ANALOG_IO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "urinterfaces/msg/detail/analog_io__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'analog_inputs'
// Member 'analog_outputs'
#include "urinterfaces/msg/detail/analog__traits.hpp"

namespace urinterfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const AnalogIO & msg,
  std::ostream & out)
{
  out << "{";
  // member: analog_inputs
  {
    if (msg.analog_inputs.size() == 0) {
      out << "analog_inputs: []";
    } else {
      out << "analog_inputs: [";
      size_t pending_items = msg.analog_inputs.size();
      for (auto item : msg.analog_inputs) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: analog_outputs
  {
    if (msg.analog_outputs.size() == 0) {
      out << "analog_outputs: []";
    } else {
      out << "analog_outputs: [";
      size_t pending_items = msg.analog_outputs.size();
      for (auto item : msg.analog_outputs) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const AnalogIO & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: analog_inputs
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.analog_inputs.size() == 0) {
      out << "analog_inputs: []\n";
    } else {
      out << "analog_inputs:\n";
      for (auto item : msg.analog_inputs) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: analog_outputs
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.analog_outputs.size() == 0) {
      out << "analog_outputs: []\n";
    } else {
      out << "analog_outputs:\n";
      for (auto item : msg.analog_outputs) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const AnalogIO & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace urinterfaces

namespace rosidl_generator_traits
{

[[deprecated("use urinterfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const urinterfaces::msg::AnalogIO & msg,
  std::ostream & out, size_t indentation = 0)
{
  urinterfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use urinterfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const urinterfaces::msg::AnalogIO & msg)
{
  return urinterfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<urinterfaces::msg::AnalogIO>()
{
  return "urinterfaces::msg::AnalogIO";
}

template<>
inline const char * name<urinterfaces::msg::AnalogIO>()
{
  return "urinterfaces/msg/AnalogIO";
}

template<>
struct has_fixed_size<urinterfaces::msg::AnalogIO>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<urinterfaces::msg::AnalogIO>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<urinterfaces::msg::AnalogIO>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // URINTERFACES__MSG__DETAIL__ANALOG_IO__TRAITS_HPP_
