// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from urinterfaces:msg/AnalogIOStateStamped.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__MSG__DETAIL__ANALOG_IO_STATE_STAMPED__STRUCT_HPP_
#define URINTERFACES__MSG__DETAIL__ANALOG_IO_STATE_STAMPED__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'io_state'
#include "urinterfaces/msg/detail/analog_io__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__urinterfaces__msg__AnalogIOStateStamped __attribute__((deprecated))
#else
# define DEPRECATED__urinterfaces__msg__AnalogIOStateStamped __declspec(deprecated)
#endif

namespace urinterfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AnalogIOStateStamped_
{
  using Type = AnalogIOStateStamped_<ContainerAllocator>;

  explicit AnalogIOStateStamped_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    io_state(_init)
  {
    (void)_init;
  }

  explicit AnalogIOStateStamped_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    io_state(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _io_state_type =
    urinterfaces::msg::AnalogIO_<ContainerAllocator>;
  _io_state_type io_state;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__io_state(
    const urinterfaces::msg::AnalogIO_<ContainerAllocator> & _arg)
  {
    this->io_state = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    urinterfaces::msg::AnalogIOStateStamped_<ContainerAllocator> *;
  using ConstRawPtr =
    const urinterfaces::msg::AnalogIOStateStamped_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<urinterfaces::msg::AnalogIOStateStamped_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<urinterfaces::msg::AnalogIOStateStamped_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::AnalogIOStateStamped_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::AnalogIOStateStamped_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::AnalogIOStateStamped_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::AnalogIOStateStamped_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<urinterfaces::msg::AnalogIOStateStamped_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<urinterfaces::msg::AnalogIOStateStamped_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__urinterfaces__msg__AnalogIOStateStamped
    std::shared_ptr<urinterfaces::msg::AnalogIOStateStamped_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__urinterfaces__msg__AnalogIOStateStamped
    std::shared_ptr<urinterfaces::msg::AnalogIOStateStamped_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AnalogIOStateStamped_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->io_state != other.io_state) {
      return false;
    }
    return true;
  }
  bool operator!=(const AnalogIOStateStamped_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AnalogIOStateStamped_

// alias to use template instance with default allocator
using AnalogIOStateStamped =
  urinterfaces::msg::AnalogIOStateStamped_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace urinterfaces

#endif  // URINTERFACES__MSG__DETAIL__ANALOG_IO_STATE_STAMPED__STRUCT_HPP_
