// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from urinterfaces:msg/DigitalIO.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__MSG__DETAIL__DIGITAL_IO__STRUCT_HPP_
#define URINTERFACES__MSG__DETAIL__DIGITAL_IO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'digital_inputs'
// Member 'digital_outputs'
#include "urinterfaces/msg/detail/digital__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__urinterfaces__msg__DigitalIO __attribute__((deprecated))
#else
# define DEPRECATED__urinterfaces__msg__DigitalIO __declspec(deprecated)
#endif

namespace urinterfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DigitalIO_
{
  using Type = DigitalIO_<ContainerAllocator>;

  explicit DigitalIO_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit DigitalIO_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _digital_inputs_type =
    std::vector<urinterfaces::msg::Digital_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<urinterfaces::msg::Digital_<ContainerAllocator>>>;
  _digital_inputs_type digital_inputs;
  using _digital_outputs_type =
    std::vector<urinterfaces::msg::Digital_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<urinterfaces::msg::Digital_<ContainerAllocator>>>;
  _digital_outputs_type digital_outputs;

  // setters for named parameter idiom
  Type & set__digital_inputs(
    const std::vector<urinterfaces::msg::Digital_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<urinterfaces::msg::Digital_<ContainerAllocator>>> & _arg)
  {
    this->digital_inputs = _arg;
    return *this;
  }
  Type & set__digital_outputs(
    const std::vector<urinterfaces::msg::Digital_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<urinterfaces::msg::Digital_<ContainerAllocator>>> & _arg)
  {
    this->digital_outputs = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    urinterfaces::msg::DigitalIO_<ContainerAllocator> *;
  using ConstRawPtr =
    const urinterfaces::msg::DigitalIO_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<urinterfaces::msg::DigitalIO_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<urinterfaces::msg::DigitalIO_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::DigitalIO_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::DigitalIO_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::DigitalIO_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::DigitalIO_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<urinterfaces::msg::DigitalIO_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<urinterfaces::msg::DigitalIO_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__urinterfaces__msg__DigitalIO
    std::shared_ptr<urinterfaces::msg::DigitalIO_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__urinterfaces__msg__DigitalIO
    std::shared_ptr<urinterfaces::msg::DigitalIO_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DigitalIO_ & other) const
  {
    if (this->digital_inputs != other.digital_inputs) {
      return false;
    }
    if (this->digital_outputs != other.digital_outputs) {
      return false;
    }
    return true;
  }
  bool operator!=(const DigitalIO_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DigitalIO_

// alias to use template instance with default allocator
using DigitalIO =
  urinterfaces::msg::DigitalIO_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace urinterfaces

#endif  // URINTERFACES__MSG__DETAIL__DIGITAL_IO__STRUCT_HPP_
