// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from urinterfaces:msg/DigitalIO.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__MSG__DETAIL__DIGITAL_IO__TRAITS_HPP_
#define URINTERFACES__MSG__DETAIL__DIGITAL_IO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "urinterfaces/msg/detail/digital_io__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'digital_inputs'
// Member 'digital_outputs'
#include "urinterfaces/msg/detail/digital__traits.hpp"

namespace urinterfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const DigitalIO & msg,
  std::ostream & out)
{
  out << "{";
  // member: digital_inputs
  {
    if (msg.digital_inputs.size() == 0) {
      out << "digital_inputs: []";
    } else {
      out << "digital_inputs: [";
      size_t pending_items = msg.digital_inputs.size();
      for (auto item : msg.digital_inputs) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: digital_outputs
  {
    if (msg.digital_outputs.size() == 0) {
      out << "digital_outputs: []";
    } else {
      out << "digital_outputs: [";
      size_t pending_items = msg.digital_outputs.size();
      for (auto item : msg.digital_outputs) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DigitalIO & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: digital_inputs
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.digital_inputs.size() == 0) {
      out << "digital_inputs: []\n";
    } else {
      out << "digital_inputs:\n";
      for (auto item : msg.digital_inputs) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: digital_outputs
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.digital_outputs.size() == 0) {
      out << "digital_outputs: []\n";
    } else {
      out << "digital_outputs:\n";
      for (auto item : msg.digital_outputs) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DigitalIO & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace urinterfaces

namespace rosidl_generator_traits
{

[[deprecated("use urinterfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const urinterfaces::msg::DigitalIO & msg,
  std::ostream & out, size_t indentation = 0)
{
  urinterfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use urinterfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const urinterfaces::msg::DigitalIO & msg)
{
  return urinterfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<urinterfaces::msg::DigitalIO>()
{
  return "urinterfaces::msg::DigitalIO";
}

template<>
inline const char * name<urinterfaces::msg::DigitalIO>()
{
  return "urinterfaces/msg/DigitalIO";
}

template<>
struct has_fixed_size<urinterfaces::msg::DigitalIO>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<urinterfaces::msg::DigitalIO>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<urinterfaces::msg::DigitalIO>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // URINTERFACES__MSG__DETAIL__DIGITAL_IO__TRAITS_HPP_
