// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from urinterfaces:msg/JointMode.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__MSG__DETAIL__JOINT_MODE__STRUCT_HPP_
#define URINTERFACES__MSG__DETAIL__JOINT_MODE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__urinterfaces__msg__JointMode __attribute__((deprecated))
#else
# define DEPRECATED__urinterfaces__msg__JointMode __declspec(deprecated)
#endif

namespace urinterfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct JointMode_
{
  using Type = JointMode_<ContainerAllocator>;

  explicit JointMode_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<uint8_t, 6>::iterator, uint8_t>(this->joint_modes.begin(), this->joint_modes.end(), 0);
      this->tool_mode = 0;
    }
  }

  explicit JointMode_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    joint_modes(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<uint8_t, 6>::iterator, uint8_t>(this->joint_modes.begin(), this->joint_modes.end(), 0);
      this->tool_mode = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _joint_modes_type =
    std::array<uint8_t, 6>;
  _joint_modes_type joint_modes;
  using _tool_mode_type =
    uint8_t;
  _tool_mode_type tool_mode;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__joint_modes(
    const std::array<uint8_t, 6> & _arg)
  {
    this->joint_modes = _arg;
    return *this;
  }
  Type & set__tool_mode(
    const uint8_t & _arg)
  {
    this->tool_mode = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t JOINT_MODE_RESET =
    235u;
  static constexpr uint8_t JOINT_MODE_SHUTTING_DOWN =
    236u;
  static constexpr uint8_t JOINT_MODE_PART_D_CALIBRATION =
    237u;
  static constexpr uint8_t JOINT_MODE_BACKDRIVE =
    238u;
  static constexpr uint8_t JOINT_MODE_POWER_OFF =
    239u;
  static constexpr uint8_t JOINT_MODE_READY_FOR_POWER_OFF =
    240u;
  static constexpr uint8_t JOINT_MODE_NOT_RESPONDING =
    245u;
  static constexpr uint8_t JOINT_MODE_MOTOR_INITIALISATION =
    246u;
  static constexpr uint8_t JOINT_MODE_BOOTING =
    247u;
  static constexpr uint8_t JOINT_MODE_PART_D_CALIBRATION_ERROR =
    248u;
  static constexpr uint8_t JOINT_MODE_BOOTLOADER =
    249u;
  static constexpr uint8_t JOINT_MODE_CALIBRATION =
    250u;
  static constexpr uint8_t JOINT_MODE_VIOLATION =
    251u;
  static constexpr uint8_t JOINT_MODE_FAULT =
    252u;
  static constexpr uint8_t JOINT_MODE_RUNNING =
    253u;
  static constexpr uint8_t JOINT_MODE_IDLE =
    255u;

  // pointer types
  using RawPtr =
    urinterfaces::msg::JointMode_<ContainerAllocator> *;
  using ConstRawPtr =
    const urinterfaces::msg::JointMode_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<urinterfaces::msg::JointMode_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<urinterfaces::msg::JointMode_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::JointMode_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::JointMode_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::JointMode_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::JointMode_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<urinterfaces::msg::JointMode_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<urinterfaces::msg::JointMode_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__urinterfaces__msg__JointMode
    std::shared_ptr<urinterfaces::msg::JointMode_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__urinterfaces__msg__JointMode
    std::shared_ptr<urinterfaces::msg::JointMode_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const JointMode_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->joint_modes != other.joint_modes) {
      return false;
    }
    if (this->tool_mode != other.tool_mode) {
      return false;
    }
    return true;
  }
  bool operator!=(const JointMode_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct JointMode_

// alias to use template instance with default allocator
using JointMode =
  urinterfaces::msg::JointMode_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointMode_<ContainerAllocator>::JOINT_MODE_RESET;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointMode_<ContainerAllocator>::JOINT_MODE_SHUTTING_DOWN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointMode_<ContainerAllocator>::JOINT_MODE_PART_D_CALIBRATION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointMode_<ContainerAllocator>::JOINT_MODE_BACKDRIVE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointMode_<ContainerAllocator>::JOINT_MODE_POWER_OFF;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointMode_<ContainerAllocator>::JOINT_MODE_READY_FOR_POWER_OFF;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointMode_<ContainerAllocator>::JOINT_MODE_NOT_RESPONDING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointMode_<ContainerAllocator>::JOINT_MODE_MOTOR_INITIALISATION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointMode_<ContainerAllocator>::JOINT_MODE_BOOTING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointMode_<ContainerAllocator>::JOINT_MODE_PART_D_CALIBRATION_ERROR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointMode_<ContainerAllocator>::JOINT_MODE_BOOTLOADER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointMode_<ContainerAllocator>::JOINT_MODE_CALIBRATION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointMode_<ContainerAllocator>::JOINT_MODE_VIOLATION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointMode_<ContainerAllocator>::JOINT_MODE_FAULT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointMode_<ContainerAllocator>::JOINT_MODE_RUNNING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointMode_<ContainerAllocator>::JOINT_MODE_IDLE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace urinterfaces

#endif  // URINTERFACES__MSG__DETAIL__JOINT_MODE__STRUCT_HPP_
