// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from urinterfaces:msg/JointMode.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__MSG__DETAIL__JOINT_MODE__TRAITS_HPP_
#define URINTERFACES__MSG__DETAIL__JOINT_MODE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "urinterfaces/msg/detail/joint_mode__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace urinterfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const JointMode & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: joint_modes
  {
    if (msg.joint_modes.size() == 0) {
      out << "joint_modes: []";
    } else {
      out << "joint_modes: [";
      size_t pending_items = msg.joint_modes.size();
      for (auto item : msg.joint_modes) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: tool_mode
  {
    out << "tool_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.tool_mode, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const JointMode & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: joint_modes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.joint_modes.size() == 0) {
      out << "joint_modes: []\n";
    } else {
      out << "joint_modes:\n";
      for (auto item : msg.joint_modes) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: tool_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "tool_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.tool_mode, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const JointMode & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace urinterfaces

namespace rosidl_generator_traits
{

[[deprecated("use urinterfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const urinterfaces::msg::JointMode & msg,
  std::ostream & out, size_t indentation = 0)
{
  urinterfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use urinterfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const urinterfaces::msg::JointMode & msg)
{
  return urinterfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<urinterfaces::msg::JointMode>()
{
  return "urinterfaces::msg::JointMode";
}

template<>
inline const char * name<urinterfaces::msg::JointMode>()
{
  return "urinterfaces/msg/JointMode";
}

template<>
struct has_fixed_size<urinterfaces::msg::JointMode>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<urinterfaces::msg::JointMode>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<urinterfaces::msg::JointMode>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // URINTERFACES__MSG__DETAIL__JOINT_MODE__TRAITS_HPP_
