// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from urinterfaces:msg/RuntimeState.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__MSG__DETAIL__RUNTIME_STATE__STRUCT_HPP_
#define URINTERFACES__MSG__DETAIL__RUNTIME_STATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__urinterfaces__msg__RuntimeState __attribute__((deprecated))
#else
# define DEPRECATED__urinterfaces__msg__RuntimeState __declspec(deprecated)
#endif

namespace urinterfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RuntimeState_
{
  using Type = RuntimeState_<ContainerAllocator>;

  explicit RuntimeState_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->data = 0;
    }
  }

  explicit RuntimeState_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->data = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _data_type =
    int8_t;
  _data_type data;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__data(
    const int8_t & _arg)
  {
    this->data = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int8_t PROGRAM_STATE_UNDEFINED =
    -1;
  static constexpr int8_t PROGRAM_STATE_STOPPING =
    0;
  static constexpr int8_t PROGRAM_STATE_STOPPED =
    1;
  static constexpr int8_t PROGRAM_STATE_RUNNING =
    2;
  static constexpr int8_t PROGRAM_STATE_PAUSING =
    3;
  static constexpr int8_t PROGRAM_STATE_PAUSED =
    4;
  static constexpr int8_t PROGRAM_STATE_RESUMING =
    5;
  static constexpr int8_t PROGRAM_STATE_RETRACTING =
    6;

  // pointer types
  using RawPtr =
    urinterfaces::msg::RuntimeState_<ContainerAllocator> *;
  using ConstRawPtr =
    const urinterfaces::msg::RuntimeState_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<urinterfaces::msg::RuntimeState_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<urinterfaces::msg::RuntimeState_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::RuntimeState_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::RuntimeState_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::RuntimeState_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::RuntimeState_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<urinterfaces::msg::RuntimeState_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<urinterfaces::msg::RuntimeState_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__urinterfaces__msg__RuntimeState
    std::shared_ptr<urinterfaces::msg::RuntimeState_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__urinterfaces__msg__RuntimeState
    std::shared_ptr<urinterfaces::msg::RuntimeState_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RuntimeState_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->data != other.data) {
      return false;
    }
    return true;
  }
  bool operator!=(const RuntimeState_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RuntimeState_

// alias to use template instance with default allocator
using RuntimeState =
  urinterfaces::msg::RuntimeState_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t RuntimeState_<ContainerAllocator>::PROGRAM_STATE_UNDEFINED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t RuntimeState_<ContainerAllocator>::PROGRAM_STATE_STOPPING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t RuntimeState_<ContainerAllocator>::PROGRAM_STATE_STOPPED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t RuntimeState_<ContainerAllocator>::PROGRAM_STATE_RUNNING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t RuntimeState_<ContainerAllocator>::PROGRAM_STATE_PAUSING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t RuntimeState_<ContainerAllocator>::PROGRAM_STATE_PAUSED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t RuntimeState_<ContainerAllocator>::PROGRAM_STATE_RESUMING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t RuntimeState_<ContainerAllocator>::PROGRAM_STATE_RETRACTING;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace urinterfaces

#endif  // URINTERFACES__MSG__DETAIL__RUNTIME_STATE__STRUCT_HPP_
