// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from urinterfaces:msg/TCPState.idl
// generated code does not contain a copyright notice
#include "urinterfaces/msg/detail/tcp_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose__functions.h"
// Member `speed`
#include "geometry_msgs/msg/detail/twist__functions.h"

bool
urinterfaces__msg__TCPState__init(urinterfaces__msg__TCPState * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    urinterfaces__msg__TCPState__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    urinterfaces__msg__TCPState__fini(msg);
    return false;
  }
  // speed
  if (!geometry_msgs__msg__Twist__init(&msg->speed)) {
    urinterfaces__msg__TCPState__fini(msg);
    return false;
  }
  return true;
}

void
urinterfaces__msg__TCPState__fini(urinterfaces__msg__TCPState * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
  // speed
  geometry_msgs__msg__Twist__fini(&msg->speed);
}

bool
urinterfaces__msg__TCPState__are_equal(const urinterfaces__msg__TCPState * lhs, const urinterfaces__msg__TCPState * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__are_equal(
      &(lhs->pose), &(rhs->pose)))
  {
    return false;
  }
  // speed
  if (!geometry_msgs__msg__Twist__are_equal(
      &(lhs->speed), &(rhs->speed)))
  {
    return false;
  }
  return true;
}

bool
urinterfaces__msg__TCPState__copy(
  const urinterfaces__msg__TCPState * input,
  urinterfaces__msg__TCPState * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__copy(
      &(input->pose), &(output->pose)))
  {
    return false;
  }
  // speed
  if (!geometry_msgs__msg__Twist__copy(
      &(input->speed), &(output->speed)))
  {
    return false;
  }
  return true;
}

urinterfaces__msg__TCPState *
urinterfaces__msg__TCPState__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  urinterfaces__msg__TCPState * msg = (urinterfaces__msg__TCPState *)allocator.allocate(sizeof(urinterfaces__msg__TCPState), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(urinterfaces__msg__TCPState));
  bool success = urinterfaces__msg__TCPState__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
urinterfaces__msg__TCPState__destroy(urinterfaces__msg__TCPState * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    urinterfaces__msg__TCPState__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
urinterfaces__msg__TCPState__Sequence__init(urinterfaces__msg__TCPState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  urinterfaces__msg__TCPState * data = NULL;

  if (size) {
    data = (urinterfaces__msg__TCPState *)allocator.zero_allocate(size, sizeof(urinterfaces__msg__TCPState), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = urinterfaces__msg__TCPState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        urinterfaces__msg__TCPState__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
urinterfaces__msg__TCPState__Sequence__fini(urinterfaces__msg__TCPState__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      urinterfaces__msg__TCPState__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

urinterfaces__msg__TCPState__Sequence *
urinterfaces__msg__TCPState__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  urinterfaces__msg__TCPState__Sequence * array = (urinterfaces__msg__TCPState__Sequence *)allocator.allocate(sizeof(urinterfaces__msg__TCPState__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = urinterfaces__msg__TCPState__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
urinterfaces__msg__TCPState__Sequence__destroy(urinterfaces__msg__TCPState__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    urinterfaces__msg__TCPState__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
urinterfaces__msg__TCPState__Sequence__are_equal(const urinterfaces__msg__TCPState__Sequence * lhs, const urinterfaces__msg__TCPState__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!urinterfaces__msg__TCPState__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
urinterfaces__msg__TCPState__Sequence__copy(
  const urinterfaces__msg__TCPState__Sequence * input,
  urinterfaces__msg__TCPState__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(urinterfaces__msg__TCPState);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    urinterfaces__msg__TCPState * data =
      (urinterfaces__msg__TCPState *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!urinterfaces__msg__TCPState__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          urinterfaces__msg__TCPState__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!urinterfaces__msg__TCPState__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
