// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from urinterfaces:msg/ToolOutputMode.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__MSG__DETAIL__TOOL_OUTPUT_MODE__STRUCT_HPP_
#define URINTERFACES__MSG__DETAIL__TOOL_OUTPUT_MODE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__urinterfaces__msg__ToolOutputMode __attribute__((deprecated))
#else
# define DEPRECATED__urinterfaces__msg__ToolOutputMode __declspec(deprecated)
#endif

namespace urinterfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ToolOutputMode_
{
  using Type = ToolOutputMode_<ContainerAllocator>;

  explicit ToolOutputMode_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->output_mode = 0;
      std::fill<typename std::array<uint8_t, 2>::iterator, uint8_t>(this->output_pin_mode.begin(), this->output_pin_mode.end(), 0);
    }
  }

  explicit ToolOutputMode_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    output_pin_mode(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->output_mode = 0;
      std::fill<typename std::array<uint8_t, 2>::iterator, uint8_t>(this->output_pin_mode.begin(), this->output_pin_mode.end(), 0);
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _output_mode_type =
    uint8_t;
  _output_mode_type output_mode;
  using _output_pin_mode_type =
    std::array<uint8_t, 2>;
  _output_pin_mode_type output_pin_mode;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__output_mode(
    const uint8_t & _arg)
  {
    this->output_mode = _arg;
    return *this;
  }
  Type & set__output_pin_mode(
    const std::array<uint8_t, 2> & _arg)
  {
    this->output_pin_mode = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t TOOL_OUTPUT =
    0u;
  static constexpr uint8_t TOOL_POWER =
    1u;
  static constexpr uint8_t OUTPUT_MODE_DISABLED =
    0u;
  static constexpr uint8_t OUTPUT_MODE_SINKING =
    1u;
  static constexpr uint8_t OUTPUT_MODE_SOURCING =
    2u;
  static constexpr uint8_t OUTPUT_MODE_PUSH_PULL =
    3u;

  // pointer types
  using RawPtr =
    urinterfaces::msg::ToolOutputMode_<ContainerAllocator> *;
  using ConstRawPtr =
    const urinterfaces::msg::ToolOutputMode_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<urinterfaces::msg::ToolOutputMode_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<urinterfaces::msg::ToolOutputMode_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::ToolOutputMode_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::ToolOutputMode_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      urinterfaces::msg::ToolOutputMode_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::msg::ToolOutputMode_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<urinterfaces::msg::ToolOutputMode_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<urinterfaces::msg::ToolOutputMode_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__urinterfaces__msg__ToolOutputMode
    std::shared_ptr<urinterfaces::msg::ToolOutputMode_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__urinterfaces__msg__ToolOutputMode
    std::shared_ptr<urinterfaces::msg::ToolOutputMode_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ToolOutputMode_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->output_mode != other.output_mode) {
      return false;
    }
    if (this->output_pin_mode != other.output_pin_mode) {
      return false;
    }
    return true;
  }
  bool operator!=(const ToolOutputMode_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ToolOutputMode_

// alias to use template instance with default allocator
using ToolOutputMode =
  urinterfaces::msg::ToolOutputMode_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ToolOutputMode_<ContainerAllocator>::TOOL_OUTPUT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ToolOutputMode_<ContainerAllocator>::TOOL_POWER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ToolOutputMode_<ContainerAllocator>::OUTPUT_MODE_DISABLED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ToolOutputMode_<ContainerAllocator>::OUTPUT_MODE_SINKING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ToolOutputMode_<ContainerAllocator>::OUTPUT_MODE_SOURCING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ToolOutputMode_<ContainerAllocator>::OUTPUT_MODE_PUSH_PULL;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace urinterfaces

#endif  // URINTERFACES__MSG__DETAIL__TOOL_OUTPUT_MODE__STRUCT_HPP_
