// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from urinterfaces:msg/ToolOutputMode.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "urinterfaces/msg/detail/tool_output_mode__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace urinterfaces
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void ToolOutputMode_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) urinterfaces::msg::ToolOutputMode(_init);
}

void ToolOutputMode_fini_function(void * message_memory)
{
  auto typed_message = static_cast<urinterfaces::msg::ToolOutputMode *>(message_memory);
  typed_message->~ToolOutputMode();
}

size_t size_function__ToolOutputMode__output_pin_mode(const void * untyped_member)
{
  (void)untyped_member;
  return 2;
}

const void * get_const_function__ToolOutputMode__output_pin_mode(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::array<uint8_t, 2> *>(untyped_member);
  return &member[index];
}

void * get_function__ToolOutputMode__output_pin_mode(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::array<uint8_t, 2> *>(untyped_member);
  return &member[index];
}

void fetch_function__ToolOutputMode__output_pin_mode(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const uint8_t *>(
    get_const_function__ToolOutputMode__output_pin_mode(untyped_member, index));
  auto & value = *reinterpret_cast<uint8_t *>(untyped_value);
  value = item;
}

void assign_function__ToolOutputMode__output_pin_mode(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<uint8_t *>(
    get_function__ToolOutputMode__output_pin_mode(untyped_member, index));
  const auto & value = *reinterpret_cast<const uint8_t *>(untyped_value);
  item = value;
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember ToolOutputMode_message_member_array[3] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(urinterfaces::msg::ToolOutputMode, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "output_mode",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(urinterfaces::msg::ToolOutputMode, output_mode),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "output_pin_mode",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    2,  // array size
    false,  // is upper bound
    offsetof(urinterfaces::msg::ToolOutputMode, output_pin_mode),  // bytes offset in struct
    nullptr,  // default value
    size_function__ToolOutputMode__output_pin_mode,  // size() function pointer
    get_const_function__ToolOutputMode__output_pin_mode,  // get_const(index) function pointer
    get_function__ToolOutputMode__output_pin_mode,  // get(index) function pointer
    fetch_function__ToolOutputMode__output_pin_mode,  // fetch(index, &value) function pointer
    assign_function__ToolOutputMode__output_pin_mode,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers ToolOutputMode_message_members = {
  "urinterfaces::msg",  // message namespace
  "ToolOutputMode",  // message name
  3,  // number of fields
  sizeof(urinterfaces::msg::ToolOutputMode),
  ToolOutputMode_message_member_array,  // message members
  ToolOutputMode_init_function,  // function to initialize message memory (memory has to be allocated)
  ToolOutputMode_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t ToolOutputMode_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &ToolOutputMode_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace urinterfaces


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<urinterfaces::msg::ToolOutputMode>()
{
  return &::urinterfaces::msg::rosidl_typesupport_introspection_cpp::ToolOutputMode_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, urinterfaces, msg, ToolOutputMode)() {
  return &::urinterfaces::msg::rosidl_typesupport_introspection_cpp::ToolOutputMode_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
