// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from urinterfaces:srv/SetDigitalOutput.idl
// generated code does not contain a copyright notice
#include "urinterfaces/srv/detail/set_digital_output__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `data`
#include "urinterfaces/msg/detail/digital__functions.h"

bool
urinterfaces__srv__SetDigitalOutput_Request__init(urinterfaces__srv__SetDigitalOutput_Request * msg)
{
  if (!msg) {
    return false;
  }
  // data
  if (!urinterfaces__msg__Digital__Sequence__init(&msg->data, 0)) {
    urinterfaces__srv__SetDigitalOutput_Request__fini(msg);
    return false;
  }
  return true;
}

void
urinterfaces__srv__SetDigitalOutput_Request__fini(urinterfaces__srv__SetDigitalOutput_Request * msg)
{
  if (!msg) {
    return;
  }
  // data
  urinterfaces__msg__Digital__Sequence__fini(&msg->data);
}

bool
urinterfaces__srv__SetDigitalOutput_Request__are_equal(const urinterfaces__srv__SetDigitalOutput_Request * lhs, const urinterfaces__srv__SetDigitalOutput_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // data
  if (!urinterfaces__msg__Digital__Sequence__are_equal(
      &(lhs->data), &(rhs->data)))
  {
    return false;
  }
  return true;
}

bool
urinterfaces__srv__SetDigitalOutput_Request__copy(
  const urinterfaces__srv__SetDigitalOutput_Request * input,
  urinterfaces__srv__SetDigitalOutput_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // data
  if (!urinterfaces__msg__Digital__Sequence__copy(
      &(input->data), &(output->data)))
  {
    return false;
  }
  return true;
}

urinterfaces__srv__SetDigitalOutput_Request *
urinterfaces__srv__SetDigitalOutput_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  urinterfaces__srv__SetDigitalOutput_Request * msg = (urinterfaces__srv__SetDigitalOutput_Request *)allocator.allocate(sizeof(urinterfaces__srv__SetDigitalOutput_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(urinterfaces__srv__SetDigitalOutput_Request));
  bool success = urinterfaces__srv__SetDigitalOutput_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
urinterfaces__srv__SetDigitalOutput_Request__destroy(urinterfaces__srv__SetDigitalOutput_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    urinterfaces__srv__SetDigitalOutput_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
urinterfaces__srv__SetDigitalOutput_Request__Sequence__init(urinterfaces__srv__SetDigitalOutput_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  urinterfaces__srv__SetDigitalOutput_Request * data = NULL;

  if (size) {
    data = (urinterfaces__srv__SetDigitalOutput_Request *)allocator.zero_allocate(size, sizeof(urinterfaces__srv__SetDigitalOutput_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = urinterfaces__srv__SetDigitalOutput_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        urinterfaces__srv__SetDigitalOutput_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
urinterfaces__srv__SetDigitalOutput_Request__Sequence__fini(urinterfaces__srv__SetDigitalOutput_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      urinterfaces__srv__SetDigitalOutput_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

urinterfaces__srv__SetDigitalOutput_Request__Sequence *
urinterfaces__srv__SetDigitalOutput_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  urinterfaces__srv__SetDigitalOutput_Request__Sequence * array = (urinterfaces__srv__SetDigitalOutput_Request__Sequence *)allocator.allocate(sizeof(urinterfaces__srv__SetDigitalOutput_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = urinterfaces__srv__SetDigitalOutput_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
urinterfaces__srv__SetDigitalOutput_Request__Sequence__destroy(urinterfaces__srv__SetDigitalOutput_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    urinterfaces__srv__SetDigitalOutput_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
urinterfaces__srv__SetDigitalOutput_Request__Sequence__are_equal(const urinterfaces__srv__SetDigitalOutput_Request__Sequence * lhs, const urinterfaces__srv__SetDigitalOutput_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!urinterfaces__srv__SetDigitalOutput_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
urinterfaces__srv__SetDigitalOutput_Request__Sequence__copy(
  const urinterfaces__srv__SetDigitalOutput_Request__Sequence * input,
  urinterfaces__srv__SetDigitalOutput_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(urinterfaces__srv__SetDigitalOutput_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    urinterfaces__srv__SetDigitalOutput_Request * data =
      (urinterfaces__srv__SetDigitalOutput_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!urinterfaces__srv__SetDigitalOutput_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          urinterfaces__srv__SetDigitalOutput_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!urinterfaces__srv__SetDigitalOutput_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


bool
urinterfaces__srv__SetDigitalOutput_Response__init(urinterfaces__srv__SetDigitalOutput_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  return true;
}

void
urinterfaces__srv__SetDigitalOutput_Response__fini(urinterfaces__srv__SetDigitalOutput_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
}

bool
urinterfaces__srv__SetDigitalOutput_Response__are_equal(const urinterfaces__srv__SetDigitalOutput_Response * lhs, const urinterfaces__srv__SetDigitalOutput_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // success
  if (lhs->success != rhs->success) {
    return false;
  }
  return true;
}

bool
urinterfaces__srv__SetDigitalOutput_Response__copy(
  const urinterfaces__srv__SetDigitalOutput_Response * input,
  urinterfaces__srv__SetDigitalOutput_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // success
  output->success = input->success;
  return true;
}

urinterfaces__srv__SetDigitalOutput_Response *
urinterfaces__srv__SetDigitalOutput_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  urinterfaces__srv__SetDigitalOutput_Response * msg = (urinterfaces__srv__SetDigitalOutput_Response *)allocator.allocate(sizeof(urinterfaces__srv__SetDigitalOutput_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(urinterfaces__srv__SetDigitalOutput_Response));
  bool success = urinterfaces__srv__SetDigitalOutput_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
urinterfaces__srv__SetDigitalOutput_Response__destroy(urinterfaces__srv__SetDigitalOutput_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    urinterfaces__srv__SetDigitalOutput_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
urinterfaces__srv__SetDigitalOutput_Response__Sequence__init(urinterfaces__srv__SetDigitalOutput_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  urinterfaces__srv__SetDigitalOutput_Response * data = NULL;

  if (size) {
    data = (urinterfaces__srv__SetDigitalOutput_Response *)allocator.zero_allocate(size, sizeof(urinterfaces__srv__SetDigitalOutput_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = urinterfaces__srv__SetDigitalOutput_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        urinterfaces__srv__SetDigitalOutput_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
urinterfaces__srv__SetDigitalOutput_Response__Sequence__fini(urinterfaces__srv__SetDigitalOutput_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      urinterfaces__srv__SetDigitalOutput_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

urinterfaces__srv__SetDigitalOutput_Response__Sequence *
urinterfaces__srv__SetDigitalOutput_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  urinterfaces__srv__SetDigitalOutput_Response__Sequence * array = (urinterfaces__srv__SetDigitalOutput_Response__Sequence *)allocator.allocate(sizeof(urinterfaces__srv__SetDigitalOutput_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = urinterfaces__srv__SetDigitalOutput_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
urinterfaces__srv__SetDigitalOutput_Response__Sequence__destroy(urinterfaces__srv__SetDigitalOutput_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    urinterfaces__srv__SetDigitalOutput_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
urinterfaces__srv__SetDigitalOutput_Response__Sequence__are_equal(const urinterfaces__srv__SetDigitalOutput_Response__Sequence * lhs, const urinterfaces__srv__SetDigitalOutput_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!urinterfaces__srv__SetDigitalOutput_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
urinterfaces__srv__SetDigitalOutput_Response__Sequence__copy(
  const urinterfaces__srv__SetDigitalOutput_Response__Sequence * input,
  urinterfaces__srv__SetDigitalOutput_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(urinterfaces__srv__SetDigitalOutput_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    urinterfaces__srv__SetDigitalOutput_Response * data =
      (urinterfaces__srv__SetDigitalOutput_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!urinterfaces__srv__SetDigitalOutput_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          urinterfaces__srv__SetDigitalOutput_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!urinterfaces__srv__SetDigitalOutput_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
