// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from urinterfaces:srv/SetSpeedFraction.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__SRV__DETAIL__SET_SPEED_FRACTION__FUNCTIONS_H_
#define URINTERFACES__SRV__DETAIL__SET_SPEED_FRACTION__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "urinterfaces/msg/rosidl_generator_c__visibility_control.h"

#include "urinterfaces/srv/detail/set_speed_fraction__struct.h"

/// Initialize srv/SetSpeedFraction message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * urinterfaces__srv__SetSpeedFraction_Request
 * )) before or use
 * urinterfaces__srv__SetSpeedFraction_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__srv__SetSpeedFraction_Request__init(urinterfaces__srv__SetSpeedFraction_Request * msg);

/// Finalize srv/SetSpeedFraction message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__srv__SetSpeedFraction_Request__fini(urinterfaces__srv__SetSpeedFraction_Request * msg);

/// Create srv/SetSpeedFraction message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * urinterfaces__srv__SetSpeedFraction_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__srv__SetSpeedFraction_Request *
urinterfaces__srv__SetSpeedFraction_Request__create();

/// Destroy srv/SetSpeedFraction message.
/**
 * It calls
 * urinterfaces__srv__SetSpeedFraction_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__srv__SetSpeedFraction_Request__destroy(urinterfaces__srv__SetSpeedFraction_Request * msg);

/// Check for srv/SetSpeedFraction message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__srv__SetSpeedFraction_Request__are_equal(const urinterfaces__srv__SetSpeedFraction_Request * lhs, const urinterfaces__srv__SetSpeedFraction_Request * rhs);

/// Copy a srv/SetSpeedFraction message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__srv__SetSpeedFraction_Request__copy(
  const urinterfaces__srv__SetSpeedFraction_Request * input,
  urinterfaces__srv__SetSpeedFraction_Request * output);

/// Initialize array of srv/SetSpeedFraction messages.
/**
 * It allocates the memory for the number of elements and calls
 * urinterfaces__srv__SetSpeedFraction_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__srv__SetSpeedFraction_Request__Sequence__init(urinterfaces__srv__SetSpeedFraction_Request__Sequence * array, size_t size);

/// Finalize array of srv/SetSpeedFraction messages.
/**
 * It calls
 * urinterfaces__srv__SetSpeedFraction_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__srv__SetSpeedFraction_Request__Sequence__fini(urinterfaces__srv__SetSpeedFraction_Request__Sequence * array);

/// Create array of srv/SetSpeedFraction messages.
/**
 * It allocates the memory for the array and calls
 * urinterfaces__srv__SetSpeedFraction_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__srv__SetSpeedFraction_Request__Sequence *
urinterfaces__srv__SetSpeedFraction_Request__Sequence__create(size_t size);

/// Destroy array of srv/SetSpeedFraction messages.
/**
 * It calls
 * urinterfaces__srv__SetSpeedFraction_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__srv__SetSpeedFraction_Request__Sequence__destroy(urinterfaces__srv__SetSpeedFraction_Request__Sequence * array);

/// Check for srv/SetSpeedFraction message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__srv__SetSpeedFraction_Request__Sequence__are_equal(const urinterfaces__srv__SetSpeedFraction_Request__Sequence * lhs, const urinterfaces__srv__SetSpeedFraction_Request__Sequence * rhs);

/// Copy an array of srv/SetSpeedFraction messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__srv__SetSpeedFraction_Request__Sequence__copy(
  const urinterfaces__srv__SetSpeedFraction_Request__Sequence * input,
  urinterfaces__srv__SetSpeedFraction_Request__Sequence * output);

/// Initialize srv/SetSpeedFraction message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * urinterfaces__srv__SetSpeedFraction_Response
 * )) before or use
 * urinterfaces__srv__SetSpeedFraction_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__srv__SetSpeedFraction_Response__init(urinterfaces__srv__SetSpeedFraction_Response * msg);

/// Finalize srv/SetSpeedFraction message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__srv__SetSpeedFraction_Response__fini(urinterfaces__srv__SetSpeedFraction_Response * msg);

/// Create srv/SetSpeedFraction message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * urinterfaces__srv__SetSpeedFraction_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__srv__SetSpeedFraction_Response *
urinterfaces__srv__SetSpeedFraction_Response__create();

/// Destroy srv/SetSpeedFraction message.
/**
 * It calls
 * urinterfaces__srv__SetSpeedFraction_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__srv__SetSpeedFraction_Response__destroy(urinterfaces__srv__SetSpeedFraction_Response * msg);

/// Check for srv/SetSpeedFraction message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__srv__SetSpeedFraction_Response__are_equal(const urinterfaces__srv__SetSpeedFraction_Response * lhs, const urinterfaces__srv__SetSpeedFraction_Response * rhs);

/// Copy a srv/SetSpeedFraction message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__srv__SetSpeedFraction_Response__copy(
  const urinterfaces__srv__SetSpeedFraction_Response * input,
  urinterfaces__srv__SetSpeedFraction_Response * output);

/// Initialize array of srv/SetSpeedFraction messages.
/**
 * It allocates the memory for the number of elements and calls
 * urinterfaces__srv__SetSpeedFraction_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__srv__SetSpeedFraction_Response__Sequence__init(urinterfaces__srv__SetSpeedFraction_Response__Sequence * array, size_t size);

/// Finalize array of srv/SetSpeedFraction messages.
/**
 * It calls
 * urinterfaces__srv__SetSpeedFraction_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__srv__SetSpeedFraction_Response__Sequence__fini(urinterfaces__srv__SetSpeedFraction_Response__Sequence * array);

/// Create array of srv/SetSpeedFraction messages.
/**
 * It allocates the memory for the array and calls
 * urinterfaces__srv__SetSpeedFraction_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
urinterfaces__srv__SetSpeedFraction_Response__Sequence *
urinterfaces__srv__SetSpeedFraction_Response__Sequence__create(size_t size);

/// Destroy array of srv/SetSpeedFraction messages.
/**
 * It calls
 * urinterfaces__srv__SetSpeedFraction_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
void
urinterfaces__srv__SetSpeedFraction_Response__Sequence__destroy(urinterfaces__srv__SetSpeedFraction_Response__Sequence * array);

/// Check for srv/SetSpeedFraction message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__srv__SetSpeedFraction_Response__Sequence__are_equal(const urinterfaces__srv__SetSpeedFraction_Response__Sequence * lhs, const urinterfaces__srv__SetSpeedFraction_Response__Sequence * rhs);

/// Copy an array of srv/SetSpeedFraction messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_urinterfaces
bool
urinterfaces__srv__SetSpeedFraction_Response__Sequence__copy(
  const urinterfaces__srv__SetSpeedFraction_Response__Sequence * input,
  urinterfaces__srv__SetSpeedFraction_Response__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // URINTERFACES__SRV__DETAIL__SET_SPEED_FRACTION__FUNCTIONS_H_
