// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from urinterfaces:srv/SetSpeedFraction.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__SRV__DETAIL__SET_SPEED_FRACTION__STRUCT_HPP_
#define URINTERFACES__SRV__DETAIL__SET_SPEED_FRACTION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__urinterfaces__srv__SetSpeedFraction_Request __attribute__((deprecated))
#else
# define DEPRECATED__urinterfaces__srv__SetSpeedFraction_Request __declspec(deprecated)
#endif

namespace urinterfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetSpeedFraction_Request_
{
  using Type = SetSpeedFraction_Request_<ContainerAllocator>;

  explicit SetSpeedFraction_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0.0f;
    }
  }

  explicit SetSpeedFraction_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0.0f;
    }
  }

  // field types and members
  using _value_type =
    float;
  _value_type value;

  // setters for named parameter idiom
  Type & set__value(
    const float & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    urinterfaces::srv::SetSpeedFraction_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const urinterfaces::srv::SetSpeedFraction_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<urinterfaces::srv::SetSpeedFraction_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<urinterfaces::srv::SetSpeedFraction_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      urinterfaces::srv::SetSpeedFraction_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::srv::SetSpeedFraction_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      urinterfaces::srv::SetSpeedFraction_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::srv::SetSpeedFraction_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<urinterfaces::srv::SetSpeedFraction_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<urinterfaces::srv::SetSpeedFraction_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__urinterfaces__srv__SetSpeedFraction_Request
    std::shared_ptr<urinterfaces::srv::SetSpeedFraction_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__urinterfaces__srv__SetSpeedFraction_Request
    std::shared_ptr<urinterfaces::srv::SetSpeedFraction_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetSpeedFraction_Request_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetSpeedFraction_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetSpeedFraction_Request_

// alias to use template instance with default allocator
using SetSpeedFraction_Request =
  urinterfaces::srv::SetSpeedFraction_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace urinterfaces


#ifndef _WIN32
# define DEPRECATED__urinterfaces__srv__SetSpeedFraction_Response __attribute__((deprecated))
#else
# define DEPRECATED__urinterfaces__srv__SetSpeedFraction_Response __declspec(deprecated)
#endif

namespace urinterfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetSpeedFraction_Response_
{
  using Type = SetSpeedFraction_Response_<ContainerAllocator>;

  explicit SetSpeedFraction_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit SetSpeedFraction_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    urinterfaces::srv::SetSpeedFraction_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const urinterfaces::srv::SetSpeedFraction_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<urinterfaces::srv::SetSpeedFraction_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<urinterfaces::srv::SetSpeedFraction_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      urinterfaces::srv::SetSpeedFraction_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::srv::SetSpeedFraction_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      urinterfaces::srv::SetSpeedFraction_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<urinterfaces::srv::SetSpeedFraction_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<urinterfaces::srv::SetSpeedFraction_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<urinterfaces::srv::SetSpeedFraction_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__urinterfaces__srv__SetSpeedFraction_Response
    std::shared_ptr<urinterfaces::srv::SetSpeedFraction_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__urinterfaces__srv__SetSpeedFraction_Response
    std::shared_ptr<urinterfaces::srv::SetSpeedFraction_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetSpeedFraction_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetSpeedFraction_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetSpeedFraction_Response_

// alias to use template instance with default allocator
using SetSpeedFraction_Response =
  urinterfaces::srv::SetSpeedFraction_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace urinterfaces

namespace urinterfaces
{

namespace srv
{

struct SetSpeedFraction
{
  using Request = urinterfaces::srv::SetSpeedFraction_Request;
  using Response = urinterfaces::srv::SetSpeedFraction_Response;
};

}  // namespace srv

}  // namespace urinterfaces

#endif  // URINTERFACES__SRV__DETAIL__SET_SPEED_FRACTION__STRUCT_HPP_
