// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from urinterfaces:srv/SetSpeedFraction.idl
// generated code does not contain a copyright notice

#ifndef URINTERFACES__SRV__DETAIL__SET_SPEED_FRACTION__TRAITS_HPP_
#define URINTERFACES__SRV__DETAIL__SET_SPEED_FRACTION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "urinterfaces/srv/detail/set_speed_fraction__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace urinterfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetSpeedFraction_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: value
  {
    out << "value: ";
    rosidl_generator_traits::value_to_yaml(msg.value, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetSpeedFraction_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "value: ";
    rosidl_generator_traits::value_to_yaml(msg.value, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetSpeedFraction_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace urinterfaces

namespace rosidl_generator_traits
{

[[deprecated("use urinterfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const urinterfaces::srv::SetSpeedFraction_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  urinterfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use urinterfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const urinterfaces::srv::SetSpeedFraction_Request & msg)
{
  return urinterfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<urinterfaces::srv::SetSpeedFraction_Request>()
{
  return "urinterfaces::srv::SetSpeedFraction_Request";
}

template<>
inline const char * name<urinterfaces::srv::SetSpeedFraction_Request>()
{
  return "urinterfaces/srv/SetSpeedFraction_Request";
}

template<>
struct has_fixed_size<urinterfaces::srv::SetSpeedFraction_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<urinterfaces::srv::SetSpeedFraction_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<urinterfaces::srv::SetSpeedFraction_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace urinterfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetSpeedFraction_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetSpeedFraction_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetSpeedFraction_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace urinterfaces

namespace rosidl_generator_traits
{

[[deprecated("use urinterfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const urinterfaces::srv::SetSpeedFraction_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  urinterfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use urinterfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const urinterfaces::srv::SetSpeedFraction_Response & msg)
{
  return urinterfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<urinterfaces::srv::SetSpeedFraction_Response>()
{
  return "urinterfaces::srv::SetSpeedFraction_Response";
}

template<>
inline const char * name<urinterfaces::srv::SetSpeedFraction_Response>()
{
  return "urinterfaces/srv/SetSpeedFraction_Response";
}

template<>
struct has_fixed_size<urinterfaces::srv::SetSpeedFraction_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<urinterfaces::srv::SetSpeedFraction_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<urinterfaces::srv::SetSpeedFraction_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<urinterfaces::srv::SetSpeedFraction>()
{
  return "urinterfaces::srv::SetSpeedFraction";
}

template<>
inline const char * name<urinterfaces::srv::SetSpeedFraction>()
{
  return "urinterfaces/srv/SetSpeedFraction";
}

template<>
struct has_fixed_size<urinterfaces::srv::SetSpeedFraction>
  : std::integral_constant<
    bool,
    has_fixed_size<urinterfaces::srv::SetSpeedFraction_Request>::value &&
    has_fixed_size<urinterfaces::srv::SetSpeedFraction_Response>::value
  >
{
};

template<>
struct has_bounded_size<urinterfaces::srv::SetSpeedFraction>
  : std::integral_constant<
    bool,
    has_bounded_size<urinterfaces::srv::SetSpeedFraction_Request>::value &&
    has_bounded_size<urinterfaces::srv::SetSpeedFraction_Response>::value
  >
{
};

template<>
struct is_service<urinterfaces::srv::SetSpeedFraction>
  : std::true_type
{
};

template<>
struct is_service_request<urinterfaces::srv::SetSpeedFraction_Request>
  : std::true_type
{
};

template<>
struct is_service_response<urinterfaces::srv::SetSpeedFraction_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // URINTERFACES__SRV__DETAIL__SET_SPEED_FRACTION__TRAITS_HPP_
